package com.benyun.service;


import java.util.List;

import com.benyun.entity.Apply;
import com.benyun.boot.core.vo.Result;
import com.benyun.vo.ApplyEventVo;
import org.beetl.sql.core.engine.PageQuery;

/**
 * 应用表(Apply)表服务
 *
 * @author makejava
 * create on 2023-03-17 10:03:25
 */
public interface ApplyService {

    Apply queryById(String id);

    List<Apply> queryAll();

    void insert(Apply apply);

    /**
     * 根据主键更新记录
     *
     * @param apply 待更新的记录.包含主键在内，如果其他列的值为空则不更新
     * @return 成功返回true，失败返回false
     */
    boolean updateById(Apply apply);

    /**
     * 根据主键删除记录
     *
     * @param id 主键
     * @return 成功返回true，反之返回false
     */
    boolean deleteById(String id);

    /**
     * 分页查询
     * @param pageQuery 封装分页条件的分页对象
     * @return pageQuery 作为一个引用，将查询结果封装进去
     */
    Result<List<Apply>> queryByPage(PageQuery<Apply> pageQuery);


    ApplyEventVo queryApplyEventByUUId(String uuid);

    List<Apply> queryList(String applyName);

    void copyFrom(String target, String from);

}
