package com.benyun.service;


import java.util.List;

import com.benyun.entity.EventLog;
import com.benyun.boot.core.vo.Result;
import com.benyun.vo.EventLogPageVo;
import com.benyun.vo.EventLogVo;
import org.beetl.sql.core.engine.PageQuery;

/**
 * 日志信息表(EventLog)表服务
 *
 * @author makejava
 * create on 2023-03-22 09:25:07
 */
public interface EventLogService {

    EventLogVo queryById(Integer id);

    List<EventLog> queryAll();

    void insert(EventLog eventLog);
    
    /**
     * 根据主键更新记录
     *
     * @param eventLog 待更新的记录.包含主键在内，如果其他列的值为空则不更新
     * @return 成功返回true，失败返回false
     */
    boolean updateById(EventLog eventLog);
    
    /**
     * 根据主键删除记录
     *
     * @param id 主键
     * @return 成功返回true，反之返回false
     */
    boolean deleteById(Integer id);
    
    /**
     * 分页查询
     * @param pageQuery 封装分页条件的分页对象
     * @return pageQuery 作为一个引用，将查询结果封装进去
     */
    Result<List<EventLog>> queryByPage(PageQuery<EventLog> pageQuery);

    EventLogPageVo queryByPage2(PageQuery<EventLogVo> pageQuery);

    void insertList(List<EventLog> eventLogList);
}
