package com.benyun.service;


import java.util.List;

import com.benyun.entity.User;
import com.benyun.boot.core.vo.Result;
import org.beetl.sql.core.engine.PageQuery;

/**
 * 用户信息表(User)表服务
 *
 * @author makejava
 * create on 2023-03-17 09:06:58
 */
public interface UserService {

    User queryById(Integer id);

    List<User> queryAll();

    void insert(User user);
    
    /**
     * 根据主键更新记录
     *
     * @param user 待更新的记录.包含主键在内，如果其他列的值为空则不更新
     * @return 成功返回true，失败返回false
     */
    boolean updateById(User user);
    
    /**
     * 根据主键删除记录
     *
     * @param id 主键
     * @return 成功返回true，反之返回false
     */
    boolean deleteById(Integer id);
    
    /**
     * 分页查询
     * @param pageQuery 封装分页条件的分页对象
     * @return pageQuery 作为一个引用，将查询结果封装进去
     */
    Result<List<User>> queryByPage(PageQuery<User> pageQuery);
}
